using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace simplePlay
{
    public partial class Form1 : Form
    {
        //private WMPLib.WindowsMediaPlayerClass player;

        public Form1() {
            InitializeComponent();

            //player = new WMPLib.WindowsMediaPlayerClass();
            //player.uiMode = "none";
            //player.enableErrorDialogs = true;
            player.MediaError += new AxWMPLib._WMPOCXEvents_MediaErrorEventHandler(player_MediaError);
            //this.Controls.Add(c);
        }

        void player_MediaError(object sender, AxWMPLib._WMPOCXEvents_MediaErrorEvent e) {
            WMPLib.IWMPMedia3 b = (WMPLib.IWMPMedia3)e.pMediaObject;
            MessageBox.Show(this, "An error occured when trying to play the media", "Media error: " + b.Error.errorCode,
                MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

        void player_MediaError(object pMediaObject) {
        }




        private void button3_Click(object sender, EventArgs e) {
            if (this.FormBorderStyle == FormBorderStyle.None) {
                this.FormBorderStyle = FormBorderStyle.Sizable;
            }
            else {
                this.FormBorderStyle = FormBorderStyle.None;
            }
        }

        private void btnPlayerControls_Click(object sender, EventArgs e) {
            if (player.uiMode == "none")
                player.uiMode = "full";
            else
                player.uiMode = "none";
        }

        private void button1_Click_1(object sender, EventArgs e) {
            if (this.TopMost)
                this.TopMost = false;
            else
                this.TopMost = true;
        }

        private void button2_Click_1(object sender, EventArgs e) {
            OpenFileDialog o = new OpenFileDialog();
            if(o.ShowDialog(this)== DialogResult.OK){
                player.URL = new System.Uri(o.FileName).ToString();
            }
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e) {
            ProcessKeyboardEvent(e.KeyCode);
        }


        private void player_KeyDownEvent(object sender, AxWMPLib._WMPOCXEvents_KeyDownEvent e) {
            ProcessKeyboardEvent((Keys)e.nKeyCode);
        }

        private void ProcessKeyboardEvent(Keys k) {
            switch (k) {
                case Keys.A:button1_Click_1(null, null);break;
                case Keys.F: button2_Click_1(null, null);break;
                case Keys.P: btnPlayerControls_Click(null, null);break;
                case Keys.W: button3_Click(null, null); break;
                case Keys.B: button3_Click_1(null, null); break;
                case Keys.Oem1:player.stretchToFit = true;break;
                //case Keys.F9:player.
                default:break;
            }
        }

        int startx, starty;
        bool moving = false;
        int alt = 0;


        private void player_MouseMoveEvent(object sender, AxWMPLib._WMPOCXEvents_MouseMoveEvent e) {
            if (alt>3 && moving && e.nButton > 0) {
                int deltax = e.fX - startx;
                int deltay = e.fY - starty;
                //startx = e.fX;
                //starty = e.fY;
                //DesktopBounds.
                DesktopBounds = new Rectangle(new Point(DesktopBounds.Location.X + deltax,
                    DesktopBounds.Location.Y + deltay), this.Size);
                alt = 0;
            }
            alt++;
        }

        private void player_MouseDownEvent(object sender, AxWMPLib._WMPOCXEvents_MouseDownEvent e) {
            startx = e.fX;
            starty = e.fY;
            moving = true;
        }

        private void player_MouseUpEvent(object sender, AxWMPLib._WMPOCXEvents_MouseUpEvent e) {
            moving = false;
        }

        private bool btns_visible = true;

        private void button3_Click_1(object sender, EventArgs e) {
            if (btns_visible) {
                this.Height -= 30;
                panel1.Visible = false;
                player.Height += 30;
                btns_visible = false;
            }
            else {
                this.Height += 30;
                panel1.Visible = true;
                player.Height -= 30;
                btns_visible = true;
            }
        }


    }
}